unit pyTrad;

interface
uses
  dvwin,
  dvcrt,
  dvinet,
  winsock,
  sysUtils,
  classes;

function abreGoogle (protoHTTP: string): boolean;
procedure fechaGoogle;
function traduzFraseGoogle (aTraduzir: string; var traduzido: string): string;

implementation
var
    sock: integer;
    pbuf: PbufRede;
    tipoHttp: string;

{-------------------------------------------------------------}

function utfToAnsi (s: string): string;
var b, b2: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    s := s + ' ';
    i := 1;
    while i <= length (s) - 1 do
        begin
            b := ord(s[i]);
            if (b < $80) or ((b and $e0) <> $c0)then
                s2 := s2 + s[i]
            else
                begin
                    b2 := ord (s[i+1]) and $3f;
                    b := (b and $03) shl 6;
                    s2 := s2 + chr(b or b2);
                    i := i + 1;
                end;
            i := i + 1;
        end;
    utfToAnsi := s2;
end;

{-------------------------------------------------------------}

function ansiToUTF (s: string): string;
var b: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    for i := 1 to length (s) do
        begin
            b := ord(s[i]);
            if b <= $7f then
                s2 := s2 + s[i]
            else
                s2 := s2 + chr ($c0 or ((b shr 6) and $3f)) +
                           chr ($80 or (b and $3f));
        end;
    ansiToUTF := s2;
end;

{-------------------------------------------------------------}

function removeHexas (s: string): string;
var i, n1, n2: integer;
    s2: string;
begin
    s2 := '';
    i := 1;
    while i <= length (s) do
        begin
            if s[i] <> '%' then
                s2 := s2 + s[i]
            else
                begin
                    i := i + 1;
                    n1 := ord(upcase(s[i])) - ord('0');
                    if n1 > 9 then n1 := n1 - 7;

                    i := i + 1;
                    n2 := ord(upcase(s[i])) - ord('0');
                    if n2 > 9 then n2 := n2 - 7;

                    s2 := s2 + chr ((n1 shl 4) + n2);
                end;
            i := i + 1;
        end;
    result := s2;
end;

{-------------------------------------------------------------}

function adicionaHexas (s: string): string;
var i: integer;
    s2: string;
begin
    s2 := '';
    for i := 1 to length(s) do
        begin
            if (ord(s[i]) > $20) and (ord(s[i]) < $80) and
               (not (s[i] in ['#', '%', '&', '<', '>', '\']))then
                s2 := s2 + s[i]
            else
                s2 := s2 + '%' + lowerCase (intToHex (ord(s[i]), 2));
        end;
    result := s2;
end;

{-------------------------------------------------------------}

function abreGoogle (protoHTTP: string): boolean;
begin
    abreGoogle := false;
    pbuf := NIL;

    abreWinSock;
    sock := abreConexao ('ajax.googleapis.com', 80);
    if sock <= 0 then
        begin
            sintetiza ('Tradutor do Google na internet est inacessvel.');
            exit;
        end;

    tipoHttp := protoHttp;
    pbuf := inicBufRede(sock);
    abreGoogle := true;
end;

{-------------------------------------------------------------}

procedure fechaGoogle;
begin
    if pbuf <> NIL then
        begin
            fimBufRede(pbuf);
            closeSocket (sock);
            pbuf := NIL;
        end;
    fechaWinsock;
end;

{-------------------------------------------------------------}

function removeUnicodes (s: string): string;
var cod, s2: string;
    i, j: integer;
begin
    i := 1;
    s2 := '';
    while i <= length (s) do
        begin
            if (i < length(s) - 6) and (copy (s, i, 6) = '\u0026') then
                begin
                    for j := i+6 to length(s) do
                        if s[j] = ';' then break;   // assumindo sempre cdigos bem formados
                    cod := copy (s, i+6, j-i-6);
                    if cod = '' then cod := ' ';    // prevenindo...

                    if cod[1] = '#'  then begin
                                               delete (cod, 1, 1);
                                               s2 := s2 + chr(strToInt (cod));
                                          end
                    else
                    if cod = 'quot' then s2 := s2 + '"'
                    else
                    if cod = 'amp'  then s2 := s2 + '&'
                    else
                    if cod = 'lt'   then s2 := s2 + '<'
                    else
                    if cod = 'gt'   then s2 := s2 + '>'
                    else
                        s2 := s2 + copy (s, i, length (cod)+1);
                    i := j + 1;
                end
            else
            if (i < length(s) - 4) and (copy (s, i, 4) = '\u00') then
                begin
                    cod := copy (s, i+4, 2);
                    hexToBin (@cod[1], @j, sizeof (j));
                    s2 := s2 + chr(j);
                    i := i + 6;
                end
            else
                begin
                    s2 := s2 + s[i];
                    i := i + 1;
                end;
        end;

    result := s2;
end;

{-------------------------------------------------------------}

function traduzFraseGoogle (aTraduzir: string; var traduzido: string): string;
var
    s, s2, x, status: string;
    p: integer;
const
    linguaOrig = 'en';
    linguaDest = 'pt';

begin
    aTraduzir := adicionaHexas(ansiToUtf (aTraduzir));
    traduzido := '';

    s := 'GET /ajax/services/language/translate?v=1.0&q=' + aTraduzir +
         '&langpair=' + linguaOrig + '%7c' + linguaDest + ' ' +
         'HTTP/' + tipoHttp;

    s := s + #$0d + #$0a +
             'Host: ajax.googleapis.com' + #$0d + #$0a +
             'Accept-Language: pt-br' + #$0d + #$0a +
             'UA-CPU: x86' + #$0d + #$0a +
             'User-Agent: Traduvox 1.0' + #$0d + #$0a;

    // writeln ('Tamanho a enviar: ', length (s), ' aperte enter');
    // readln;
    writelnRede (sock, s);
    readlnBufRede(pbuf, status, 10000);
    // writeln (status);
    result := status;

    s2 := status;
    while s2 <> '' do
        begin
            readlnBufRede(pbuf, s2, 3000);
            // writeln (s2);
        end;

    if tipoHttp = '1.1' then
        begin
            readlnBufRede(pbuf, x, 80);
            readlnBufRede(pbuf, s2, 3000);
            readlnBufRede(pbuf, x, 80);
            readlnBufRede(pbuf, x, 80);
        end
    else
        readlnBufRede(pbuf, s2, 3000);

    p := pos ('"translatedText":', s2);
    delete (s2, 1, p+17);
    p := pos ('"', s2);
    if p <> 0 then
        traduzido := copy (s2, 1, p-1);
    traduzido := utfToAnsi (removeHexas (traduzido));
    traduzido := removeUnicodes (traduzido);

    if copy (traduzido, 0, 3) = '''m ' then   // pequeno erro do google translator
         insert ('I', traduzido, 1);
end;

end.
